<?php

/**
 * consol_categoria actions.
 *
 * @package    controlComisiones
 * @subpackage consol_categoria
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class consol_categoriaActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.tipter ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $id_anhos = $request['id_anhos'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];


            /*
             * Variables opcionales
             */
            //Caja Menor
            if (isset($request['id_proyecto'])) {
                $whereCajaMenor = " AND tab0.id_proyecto = " . $request['id_proyecto'];
            } else {
                $whereCajaMenor = ' ';
            }
            //tipter
            if (isset($request['tipter'])) {
                $whereTipTer = " AND tab0.tipter = " . $request['tipter'];
            } else {
                $whereTipTer = ' ';
            }
            //estado - true por 1 y false por 0
            if (isset($request['estado'])) {
                if ($request['estado'] == 'true') {
                    //Si es true
                    $estado = 1;
                    $whereEstado = " AND tab0.estado = 1 ";
                } elseif ($request['estado'] == '0') {
                    //Si es 0
                    $estado = 0;
                    $whereEstado = " AND tab0.estado = 0 ";
                } else {
                    //Si es false
                    $estado = 0;
                    $whereEstado = " ";
                }
            }





            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 

tab0.id_anhos,
tab0.tipo_comisionado,
tab0.tipter,
sum(nvl(enero,0)) AS ENERO,
sum(nvl(febrero,0)) AS FEBRERO,
sum(nvl(marzo,0)) AS MARZO,
sum(nvl(abril,0)) AS ABRIL,
sum(nvl(mayo,0)) AS MAYO,
sum(nvl(junio,0)) AS JUNIO,
sum(nvl(julio,0)) AS JULIO,
sum(nvl(agosto,0)) AS AGOSTO,
sum(nvl(septiembre,0)) AS SEPTIEMBRE,
sum(nvl(octubre,0)) AS OCTUBRE,
sum(nvl(noviembre,0)) AS NOVIEMBRE,
sum(nvl(diciembre,0)) AS DICIEMBRE,
sum(nvl(total,0)) AS TOTAL
FROM(

    select 
    tab0.id_anhos,
    tab3.id_proyecto,
    tab0.estado,
    tab5.tipter,
    tab5.DESCRIPCION AS TIPO_COMISIONADO,
    case when to_char(tab2.fecha_resolucion,'mm') = '01' then round(tab0.valor_neto)  else 0 end as enero,
    case when to_char(tab2.fecha_resolucion,'mm') = '02' then round(tab0.valor_neto)  else 0 end as febrero,
    case when to_char(tab2.fecha_resolucion,'mm') = '03' then round(tab0.valor_neto)  else 0 end as marzo,
    case when to_char(tab2.fecha_resolucion,'mm') = '04' then round(tab0.valor_neto)  else 0 end as abril,
    case when to_char(tab2.fecha_resolucion,'mm') = '05' then round(tab0.valor_neto)  else 0 end as mayo,
    case when to_char(tab2.fecha_resolucion,'mm') = '06' then round(tab0.valor_neto)  else 0 end as junio,
    case when to_char(tab2.fecha_resolucion,'mm') = '07' then round(tab0.valor_neto)  else 0 end as julio,
    case when to_char(tab2.fecha_resolucion,'mm') = '08' then round(tab0.valor_neto)  else 0 end as agosto,
    case when to_char(tab2.fecha_resolucion,'mm') = '09' then round(tab0.valor_neto)  else 0 end as septiembre,
    case when to_char(tab2.fecha_resolucion,'mm') = '10' then round(tab0.valor_neto)  else 0 end as octubre,
    case when to_char(tab2.fecha_resolucion,'mm') = '11' then round(tab0.valor_neto)  else 0 end as noviembre,
    case when to_char(tab2.fecha_resolucion,'mm') = '12' then round(tab0.valor_neto)  else 0 end as diciembre,
    tab0.valor_neto as TOTAL
    
    
    from COM_PAGO_EGRESO tab0
    join com_cuenta tab1 ON tab1.id_cuenta = tab0.id_cuenta
    join com_resolucion tab2 ON tab2.id_resolucion = tab1.id_resolucion
    join COM_COMISION tab3 ON tab3.ID_COMISION = tab2.id_comision
    left join com_tercero tab4 ON tab4.id_tercero = tab1.id_tercero
    left join COM_TIPO_COMISIONADO tab5 ON tab5.tipter = tab4.tipter

    where
    tab3.fecha_inicio between to_date( '$fecha_ini' , 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )

)tab0
where 
tab0.id_anhos = $id_anhos                     
$whereCajaMenor $whereTipTer    
$whereEstado                      

group by 
tab0.id_anhos, 
tab0.tipo_comisionado,
tab0.tipter 

) 
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 

tab0.id_anhos,
tab0.tipo_comisionado,
tab0.tipter,
sum(nvl(enero,0)) AS ENERO,
sum(nvl(febrero,0)) AS FEBRERO,
sum(nvl(marzo,0)) AS MARZO,
sum(nvl(abril,0)) AS ABRIL,
sum(nvl(mayo,0)) AS MAYO,
sum(nvl(junio,0)) AS JUNIO,
sum(nvl(julio,0)) AS JULIO,
sum(nvl(agosto,0)) AS AGOSTO,
sum(nvl(septiembre,0)) AS SEPTIEMBRE,
sum(nvl(octubre,0)) AS OCTUBRE,
sum(nvl(noviembre,0)) AS NOVIEMBRE,
sum(nvl(diciembre,0)) AS DICIEMBRE,
sum(nvl(total,0)) AS TOTAL
FROM(

    select 
    tab0.id_anhos,
    tab3.id_proyecto,
    tab0.estado,
    tab5.tipter,
    tab5.DESCRIPCION AS TIPO_COMISIONADO,
    case when to_char(tab2.fecha_resolucion,'mm') = '01' then round(tab0.valor_neto)  else 0 end as enero,
    case when to_char(tab2.fecha_resolucion,'mm') = '02' then round(tab0.valor_neto)  else 0 end as febrero,
    case when to_char(tab2.fecha_resolucion,'mm') = '03' then round(tab0.valor_neto)  else 0 end as marzo,
    case when to_char(tab2.fecha_resolucion,'mm') = '04' then round(tab0.valor_neto)  else 0 end as abril,
    case when to_char(tab2.fecha_resolucion,'mm') = '05' then round(tab0.valor_neto)  else 0 end as mayo,
    case when to_char(tab2.fecha_resolucion,'mm') = '06' then round(tab0.valor_neto)  else 0 end as junio,
    case when to_char(tab2.fecha_resolucion,'mm') = '07' then round(tab0.valor_neto)  else 0 end as julio,
    case when to_char(tab2.fecha_resolucion,'mm') = '08' then round(tab0.valor_neto)  else 0 end as agosto,
    case when to_char(tab2.fecha_resolucion,'mm') = '09' then round(tab0.valor_neto)  else 0 end as septiembre,
    case when to_char(tab2.fecha_resolucion,'mm') = '10' then round(tab0.valor_neto)  else 0 end as octubre,
    case when to_char(tab2.fecha_resolucion,'mm') = '11' then round(tab0.valor_neto)  else 0 end as noviembre,
    case when to_char(tab2.fecha_resolucion,'mm') = '12' then round(tab0.valor_neto)  else 0 end as diciembre,
    tab0.valor_neto as TOTAL
    
    
    from COM_PAGO_EGRESO tab0
    join com_cuenta tab1 ON tab1.id_cuenta = tab0.id_cuenta
    join com_resolucion tab2 ON tab2.id_resolucion = tab1.id_resolucion
    join COM_COMISION tab3 ON tab3.ID_COMISION = tab2.id_comision
    left join com_tercero tab4 ON tab4.id_tercero = tab1.id_tercero
    left join COM_TIPO_COMISIONADO tab5 ON tab5.tipter = tab4.tipter

    where
    tab3.fecha_inicio between to_date( '$fecha_ini' , 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )

)tab0
where 
tab0.id_anhos = $id_anhos                     
$whereCajaMenor $whereTipTer    
$whereEstado                      

group by 
tab0.id_anhos, 
tab0.tipo_comisionado,
tab0.tipter 
                    
$sortBy                    
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[consol_categoria] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
